/*-----------------------------------------------------------------------
/  ި ̪Pʕݸٰ ̧   (C)ChaN, 2014
/-----------------------------------------------------------------------*/

#ifndef _DISKIO_DEFINED
#define _DISKIO_DEFINED

#ifdef __cplusplus
extern "C" {
#endif

#define _USE_WRITE	1	/* 1: Enable disk_write function */
#define _USE_IOCTL	1	/* 1: Enable disk_ioctl fucntion */

#include "integer.h"

typedef BYTE	DSTATUS;	/* ި֐̏ */

typedef enum {				/* ި֐̌ */
	RES_OK = 0,				/* 0:  */
	RES_ERROR,				/* 1: ǂݏُ */
	RES_WRPRT,				/* 2: ݕی */
	RES_NOTRDY,				/* 3: Z */
	RES_PARERR				/* 4: Ұ */
} DRESULT;

/*---------------------------------------*/
/* ި֐^錾 */

DSTATUS disk_initialize (BYTE pdrv);
DSTATUS disk_status (BYTE pdrv);
DRESULT disk_read (BYTE pdrv, BYTE* buff, DWORD sector, UINT count);
#if _USE_WRITE
DRESULT disk_write (BYTE pdrv, const BYTE* buff, DWORD sector, UINT count);
#endif
#if _USE_IOCTL
DRESULT disk_ioctl (BYTE pdrv, BYTE cmd, void* buff);
#endif
void disk_timerproc (void);

/* ިޯ(DSTATUS) */
#define STA_NOINIT		0x01	/* ײ */
#define STA_NODISK		0x02	/* ײޓ}̂Ȃ */
#define STA_PROTECT		0x04	/* ݕی */

/* disk_ioctrl֐pߕ */

/* (FatFsɂĎgp)W */
#define CTRL_SYNC			0	/* ۗݏ(v _FS_READONLY == 0) */
#define GET_SECTOR_COUNT	1	/* }̂̑傫擾 (v _USE_MKFS == 1) */
#define GET_SECTOR_SIZE		2	/* ̑傫擾 (v _MAX_SS != _MIN_SS) */
#define GET_BLOCK_SIZE		3	/* ̑傫擾 (v _USE_MKFS == 1) */
#define CTRL_TRIM			4	/* ͂gpĂȂ̉ް𑕒uɒʒm (v _USE_TRIM == 1) */

/* (FatFsɂĎgpȂ)W */
#define CTRL_FORMAT			5	/* }̏ŕ̫ϯĂ쐬 */
#define CTRL_POWER_IDLE		6	/* uُԂɒu */
#define CTRL_POWER_OFF		7	/* uOFFԂɒu */
#define CTRL_LOCK			8	/* }̎O{ */
#define CTRL_UNLOCK			9	/* }̎O */
#define CTRL_EJECT			10	/* }̔r */

/* (FatFsɂĎgpȂ)MMC/SDCL */
#define MMC_GET_TYPE		50	/* ތ`擾 */
#define MMC_GET_CSD			51	/* CSD擾 */
#define MMC_GET_CID			52	/* CID擾 */
#define MMC_GET_OCR			53	/* OCR擾 */
#define MMC_GET_SDSTAT		54	/* SDԎ擾 */

/* (FatFsɂĎgpȂ)ATA/CFL */
#define ATA_GET_REV			60	/* F/WŎ擾 */
#define ATA_GET_MODEL		61	/* ^擾 */
#define ATA_GET_SN			62	/* ʔԎ擾 */


/* MMCތ`׸(MMC_GET_TYPE) */
#define CT_MMC		0x01		/* MMC3 */
#define CT_SD1		0x02		/* SD1 */
#define CT_SD2		0x04		/* SD2 */
#define CT_SDC		(CT_SD1|CT_SD2)	/* SD */
#define CT_BLOCK	0x08		/* ڽw */

#ifdef __cplusplus
}
#endif

#endif
