/**
 * \file
 *
 * \brief ǏڰъɏՕ
 *
 * 쌠 (c) 2011-2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *    Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *    ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *    (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *    ł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "gfx_mono_framebuffer.h"

static uint8_t *fbpointer;	/* gfx_mono_set_framebuffer֐ɂčXVڰъɏՕւ̈ʒuwq */

/* \brief LCDڰъɏՕݒ
 *
 * \param framebuffer	ڰъɏՕێł悤Ɋ蓖ĂꂽRAM̗̈ւ̈ʒuwq
 *
 * ȗ:
 * \code
	uint8_t framebuffer[FRAMEBUFFER_SIZE];
	gfx_mono_set_framebuffer(framebuffer);
\endcode
 */
void gfx_mono_set_framebuffer(uint8_t *framebuffer)
{
	fbpointer = framebuffer;
}

/**
 * \brief RAMڰъɏՕ߰ނzu
 *
 * \param data		ׂްւ̈ʒuwq
 * \param page		߰ ڽ
 * \param column	߰ޓł̕ψ (XW)
 * \param width		ׂ޲Đ
 *
 * ȉ̗data_buf߰0A10(ڰъɏՕ޲10`42)32޲Ă܂B
 * \code
	gfx_mono_framebuffer_put_page(data_buf, 0, 10, 32);
\endcode
 */
void gfx_mono_framebuffer_put_page(gfx_mono_color_t *data, gfx_coord_t page,
		gfx_coord_t column, gfx_coord_t width)
{
	gfx_mono_color_t *data_pt = data;
	gfx_coord_t *framebuffer_pt = fbpointer +
			((page * GFX_MONO_LCD_WIDTH) + column);

	do {
		*framebuffer_pt++ = *data_pt++;
	} while (--width > 0);
}

/**
 * \brief ڰъɏՕ߰ޓǂݍ
 *
 * \param data		ǂްi[ꏊւ̈ʒuwq
 * \param page		߰ ڽ
 * \param column	߰ޓł̕ψ (XW)
 * \param width		ǂ܂ׂ޲Đ
 *
 * ȉ̗ڰъɏՕŏ128޲(ŏ߰)ǂݖ߂܂B
 * \code
	gfx_mono_framebuffer_get_page(read_buffer, 0, 0, 128);
\endcode
 */
void gfx_mono_framebuffer_get_page(gfx_mono_color_t *data, gfx_coord_t page, \
		gfx_coord_t column, gfx_coord_t width)
{
	gfx_coord_t *framebuffer_pt = fbpointer +
			((page * GFX_MONO_LCD_WIDTH) + column);
	do {
		*data++ = *framebuffer_pt++;
	} while (--width > 0);
}

/**
 * \brief ڰъɏՕ߸ٕ`
 *
 * \param x			߸قXW
 * \param y			߸قYW
 * \param color		߸ّ
 */
void gfx_mono_framebuffer_draw_pixel(gfx_coord_t x, gfx_coord_t y,
		gfx_mono_color_t color)
{
	uint8_t page;
	uint8_t pixel_mask;
	uint8_t pixel_value;

	/* ʊOɕ`悳߸قj */
	if ((x > GFX_MONO_LCD_WIDTH - 1) || (y > GFX_MONO_LCD_HEIGHT - 1)) {
		return;
	}

	page = y / GFX_MONO_LCD_PIXELS_PER_BYTE;
	pixel_mask = (1 << (y - (page * 8)));

	/*
	 * ֗^߸ق܂߰ނǂŁǍɂ߰ނ\ɏ߂O
	 * ɂ߸قŗvꂽs܂B
	 */
	pixel_value = gfx_mono_framebuffer_get_byte(page, x);
	switch (color) {
	case GFX_PIXEL_SET:
		pixel_value |= pixel_mask;
		break;
	case GFX_PIXEL_CLR:
		pixel_value &= ~pixel_mask;
		break;
	case GFX_PIXEL_XOR:
		pixel_value ^= pixel_mask;
		break;
	default:
		break;
	}
	gfx_mono_framebuffer_put_byte(page, x, pixel_value);
}

/**
 * \brief ڰъɏՕx,y߸ْl擾
 *
 * \param x			߸قXW
 * \param y			߸YW
 * \return			߸قݒ肳ĂΔ0l
 *
 */
uint8_t gfx_mono_framebuffer_get_pixel(gfx_coord_t x, gfx_coord_t y)
{
	uint8_t page;
	uint8_t pixel_mask;

	if ((x > GFX_MONO_LCD_WIDTH - 1) || (y > GFX_MONO_LCD_HEIGHT - 1)) {
		return 0;
	}

	page = y / GFX_MONO_LCD_PIXELS_PER_BYTE;
	pixel_mask = (1 << (y - (page * 8)));

	return gfx_mono_framebuffer_get_byte(page, x) & pixel_mask;
}

/**
 * \brief ڰъɏՕ޲Ăzu
 *
 * \param page		߰ ڽ
 * \param column	߰ޕψ (XW)
 * \param data		ׂް
 *
 * ̗ڰъɏՕ̍ŏ޲Ă0xFF̒lzu܂B
 * \code
	gfx_mono_framebuffer_put_byte(0, 0, 0xFF);
\endcode
 */
void gfx_mono_framebuffer_put_byte(gfx_coord_t page, gfx_coord_t column,
		uint8_t data)
{
	*(fbpointer + (page * GFX_MONO_LCD_WIDTH) + column) = data;
}

/**
 * \brief ڰъɏՕ޲Ă擾
 *
 * \param page		߰ ڽ
 * \param column	߰ޕψ (XW)
 * \return			LCD܂ڰъɏՕް
 *
 * ȉ̺ނڰъɏՕ̍ŏ޲Ăǂ݂܂B
 * \code
	data = gfx_mono_framebuffer_get_byte(0, 0);
\endcode
 */
uint8_t gfx_mono_framebuffer_get_byte(gfx_coord_t page, gfx_coord_t column)
{
	return *(fbpointer + (page * GFX_MONO_LCD_WIDTH) + column);
}

/**
 * \brief ̴ъɏՕ޲ĂǂŕύXď܂B
 *
 * ̊֐ڰъɏՕ޲ĂǂŁAcolorƒ񋟂ꂽ߸َՕ(pixel_m
 * ask)ɂđIꂽ߸ّɏ]Ă޲ĂŎՕs܂B
 *
 * \param page			߰ ڽ
 * \param column		߰ޕψ (XW)
 * \param pixel_mask	߸ّpՕ
 * \param color			߸ّ
 *
 * ڰъɏՕ̍ŏ޲Ă0xAAXOR鏬ȗ
 * \code
	gfx_mono_framebuffer_mask_byte(0,0,0xAA,GFX_PIXEL_XOR);
\endcode
 */
void gfx_mono_framebuffer_mask_byte(gfx_coord_t page, gfx_coord_t column,
		gfx_mono_color_t pixel_mask, gfx_mono_color_t color)
{
	gfx_mono_color_t temp;

	temp = gfx_mono_get_byte(page, column);

	switch (color) {
	case GFX_PIXEL_SET:
		temp |= pixel_mask;
		break;
	case GFX_PIXEL_CLR:
		temp &= ~pixel_mask;
		break;
	case GFX_PIXEL_XOR:
		temp ^= pixel_mask;
		break;
	}
	gfx_mono_put_byte(page, column, temp);
}
