/**
 * \file
 *
 * \brief ̨ ײAPIͯ ̧
 *
 * 쌠 (c) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *    Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *    ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *    (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *    ł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef GFX_MONO_TEXT_H_INCLUDED
#define GFX_MONO_TEXT_H_INCLUDED

#include <stdint.h>

#include <avr/io.h>
#include "progmem.h"
#ifdef CONFIG_HAVE_HUGEMEM
# include "hugemem.h"
#endif

/**
 * \ingroup gfx_mono
 * \defgroup gfx_mono_font x̫
 * ̒Pʕ͕\ɔ̫Ăo͂邽߂̋@\񋟂܂B
 * @{
 */

/**
 * \brief ̫ ްp̗LȋLʒu
 *
 * \todo ʏRAM̫ėpxǉ
 */
enum font_data_type {
	FONT_LOC_PROGMEM,		/** ۸/ׯ ؂Ɋi[ꂽ̫ ް */
#ifdef CONFIG_HAVE_HUGEMEM
	FONT_LOC_HUGEMEM,		/** HUGEMEMɊi[ꂽ̫ ް */
#endif
};

/** ̫  ްpL\ */
struct font {
	/** 2i̫ ްɎgpĽ`B\ref font_data_type B */
	enum font_data_type type;
	union {
		/**
		 * 2i̫ ްi[ꂽꏊւ̈ʒuwqB\a type ̒lɈˑ
		 * hugemem܂progmem̂ǂ炩ʂıϐłB
		 */
#ifdef CONFIG_HAVE_HUGEMEM
		hugemem_ptr_t hugemem;
#endif
		uint8_t PROGMEM_PTR_T progmem;
	} data;
	uint8_t width;			/** ߸قł1̫ĕ̕ */
	uint8_t height;			/** ߸قł1̫ĕ̍ */
	uint8_t first_char;		/** ̫đg̍ŏ̕ASCIIl */
	uint8_t last_char;		/** ̫đg̍Ō̕ASCIIl */
};

/** \name RAMɒuꂽƕ */
/** @{ */
void gfx_mono_draw_char(const char c, const gfx_coord_t x, const gfx_coord_t y,
		const struct font *font);

void gfx_mono_draw_string(const char *str, const gfx_coord_t x,
		const gfx_coord_t y, const struct font *font);

void gfx_mono_get_string_bounding_box(char const *str, const struct font *font,
		gfx_coord_t *width, gfx_coord_t *height);

/** @} */

/** \name ׯ ؂ɒuꂽ */
/** @{ */
void gfx_mono_draw_progmem_string(char PROGMEM_PTR_T str, gfx_coord_t x,
		gfx_coord_t y, const struct font *font);

void gfx_mono_get_progmem_string_bounding_box(char PROGMEM_PTR_T str,
		const struct font *font, gfx_coord_t *width,
		gfx_coord_t *height);

/** @} */

/** @} */

#endif /* GFX_MONO_TEXT_H_INCLUDED */
